-- ****************************************************************************
-- ****************************************************************************
--
-- Converting ratings to percentages
--
-- ****************************************************************************
-- ****************************************************************************

-- Adjusted for CalcStat use By Giseldah

import "MaKoPlugins.Utils";

import (string.gsub(getfenv(1)._.Name,"%.Conversion","")..".CalcStat");

-- ****************************************************************************
-- ****************************************************************************
--
-- Rating to percentage conversions. Reference:
--
--     https://lotro-wiki.com/index.php/Rating_to_percentage_formula
--
-- ****************************************************************************
-- ****************************************************************************

-- ----------------------------------------------------------------------------
-- Stat name mapping for CalcStat
-- ----------------------------------------------------------------------------

local CSNames = {
	["LightArmor"]  = "MitLight",
	["MediumArmor"] = "MitMedium",
	["HeavyArmor"]  = "MitHeavy",
	["BlockPE"] = "Block",
	["BParryE"] = "Parry",
	["BPEvade"] = "Evade",
	["PartialBPE"] = "PartBPE",
	["PartialBPEMit"] = "PartMit",
	["Resistance"] = "Resist",
	["CritRate"] = "CritHit",
	["DevRate"] = "DevHit",
	["CritMag"] = "CritMagn",
	["CritDef"] = "CritDef",
	["Finesse"] = "Finesse",
	["OutHeals"] = "OutHeal",
	["IncHeals"] = "InHeal",
	["Mastery"] = "PhyDmg"
}

-- ----------------------------------------------------------------------------

function ratingToPercentage(key, R, L)
    if R ~= nil then
		local SName = CSNames[key]
		if SName ~= nil then
			return CalcStat(SName.."PRatP",L,R) + 0.0002 + CalcStat(SName.."PBonus",L)
		end
    end
    return nil
end

function ratingCap(key, L)
	local SName = CSNames[key]
	if SName ~= nil then
		return CalcStat(SName.."PRatPCapR",L)
	end
	return nil
end
